package cokr.xit.fims.payer.web;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import cokr.xit.fims.payer.Payer;
import cokr.xit.fims.payer.PayerQuery;
import cokr.xit.fims.payer.service.PayerService;
import cokr.xit.foundation.web.AbstractController;
import cokr.xit.interfaces.lvis.service.reg.BasicInfoRequest;

/**납부자 서비스의 웹 컨트롤러
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-18	mjkhan 최초 작성
 * ================================
 * </pre>
 */
@Controller
@RequestMapping(name = "납부자", value = "/payer")
public class PayerController extends AbstractController {
	/**납부자 서비스*/
	@Resource(name = "payerService")
	private PayerService payerService;

	/**납부자 관리 메인화면(payer/payer-main)을 연다.
	 * 조건없는 {@link #getPayerList(PayerQuery) 납부자 조회 결과}를 포함시킨다.
	 * @return /payer/payer-main
	 */
	@RequestMapping(name = "납부자 메인", value = "/main.do")
	public ModelAndView main() {
		ModelAndView mav = getPayerList(new PayerQuery().setPageNum(1));
		mav.setViewName("/payer/payer-main");
		return mav.addObject("payerList", toJson(mav.getModel().get("payerList")));
	}

	/**납부자 목록을 조회하여 반환한다.<br />
	 * {@link PayerService#getPayerList(PayerQuery)} 참고
	 * @param req 납부자 조회 조건
	 * @return jsonView
	 * <pre><code> {
	 *     "payerList": [납부자 목록]
	 *     "payerStart": 납부자 목록 시작 인덱스
	 *     "payerFetch": 한 번에 가져오는 납부자 목록 수
	 *     "payerTotal": 조회 결과 찾은 전체 납부자 수
	 * }</code></pre>
	 */
	@RequestMapping(name = "납부자 조회", value = "/list.do")
	public ModelAndView getPayerList(PayerQuery req) {
		List<?> result = payerService.getPayerList(setFetchSize(req));
		return setCollectionInfo(new ModelAndView("jsonView"), result, "payer");
	}

	/**납부자를 등록한다.
	 * @param payer 납부자 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 등록되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "납부자 등록", value = "/create.do")
	public ModelAndView create(Payer payer) {
		boolean saved = payerService.create(payer);
		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**납부자 정보를 수정한다.
	 * @param payer 납부자 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 수정되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "납부자 수정", value = "/update.do")
	public ModelAndView update(Payer payer) {
		boolean saved = payerService.update(payer);
		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**지정한 납부자를 제거한다.
	 * @param payerIDs 납부자 아이디
	 * @return jsonView
	 * <pre><code> {
	 *     "affected": 저장된 정보수
	 *     "saved": 저장되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "납부자 제거", value = "/remove.do")
	public ModelAndView remove(String... rtpyrIds) {
		int affected = payerService.remove(rtpyrIds);
		return new ModelAndView("jsonView")
			.addObject("affected", affected)
			.addObject("saved", affected > 0);
	}

	@PostMapping(name = "차량/납부자 조회", value = "/vehicle.do")
	public ModelAndView getVehicleOwner(BasicInfoRequest req) {
		Payer payer = payerService.getVehicleOwner(req);
		boolean found = payer != null;
		return new ModelAndView("jsonView")
			.addObject("found", found)
			.addObject("rtpyrId", found ? payer.getRtpyrId() : null)
			.addObject("vehicle", found ? payer.getVehicleInfo() : null);
	}
}